Index: /trunk/LMDZ.GENERIC/libf/phystd/sfluxv.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/sfluxv.F	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/sfluxv.F	(revision 253)
@@ -1,4 +1,4 @@
       SUBROUTINE SFLUXV(DTAUV,TAUV,TAUCUMV,RSFV,DWNV,WBARV,COSBV,
-     *                  UBAR0,STEL,GWEIGHT,NFLUXTOPV,NFLUXTOPV_nu,
+     *                  UBAR0,STEL,GWEIGHT,NFLUXTOPV,NFLUXGNDV_nu,
      *                  FMNETV,FLUXUPV,FLUXDNV,FZEROV,taugsurf)
 
@@ -19,6 +19,6 @@
       real*8 NFLUXTOPV, FLUXUP, FLUXDN
       real*8 NFLUXTOPV_nu(L_NSPECTV)
+      real*8 NFLUXGNDV_nu(L_NSPECTV)
       real*8 GWEIGHT(L_NGAUSS)
-
 
       integer L, NG, NW, NG1,k
@@ -27,5 +27,4 @@
 
       real*8 DIFFV, DIFFVT
-
       real*8 taugsurf(L_NSPECTV,L_NGAUSS-1), fzero
 
@@ -38,4 +37,8 @@
       NFLUXTOPV = 0.0
 
+      DO NW=1,L_NSPECTV
+         NFLUXTOPV_nu(NW)=0.0
+         NFLUXGNDV_nu(NW)=0.0
+      END DO
 
       DO L=1,L_NLAYRAD
@@ -54,5 +57,4 @@
         F0PI = STEL(NW)
 
-
         FZERO = FZEROV(NW)
         IF(FZERO.ge.0.99) goto 40
@@ -68,11 +70,16 @@
 C         SET UP THE UPPER AND LOWER BOUNDARY CONDITIONS ON THE VISIBLE
 
-          BTOP = 0.0
-
+          BTOP  = 0.0
+          !BSURF = 0./0. ! why was this here?
+          BSURF = 0.
 C         LOOP OVER THE NTERMS BEGINNING HERE
  
+
+!      FACTOR    = 1.0D0 - WDEL(1)*CDEL(1)**2
+!      TAU(1)    = TDEL(1)*FACTOR
+
+
           ETERM = MIN(TAUV(L_NLEVRAD,NW,NG),TAUMAX)
           BSURF = RSFV*UBAR0*STEL(NW)*EXP(-ETERM/UBAR0)
-
 
 C         WE CAN NOW SOLVE FOR THE COEFFICIENTS OF THE TWO STREAM
@@ -84,9 +91,7 @@
 
 
-
           CALL GFLUXV(DTAUV(1,NW,NG),TAUV(1,NW,NG),TAUCUMV(1,NW,NG),
      *                WBARV(1,NW,NG),COSBV(1,NW,NG),UBAR0,F0PI,RSFV,
      *                BTOP,BSURF,FMUPV,FMDV,DIFFV,FLUXUP,FLUXDN)
-
 
 C         NOW CALCULATE THE CUMULATIVE VISIBLE NET FLUX 
@@ -103,8 +108,14 @@
           END DO
 
-c         and same thing by spectral band... (RDW)
+c     and same thing by spectral band... (RDW)
           NFLUXTOPV_nu(NW) = NFLUXTOPV_nu(NW)
      *      +(FLUXUP-FLUXDN)*GWEIGHT(NG)*
      *                          (1.0-FZEROV(NW))
+
+
+c     flux at gnd (RDW)
+          NFLUXGNDV_nu(NW) = NFLUXGNDV_nu(NW)
+     *      +FMDV(L_NLAYRAD)*GWEIGHT(NG)*(1.0-FZEROV(NW))
+
 
 C         THE DIFFUSE COMPONENT OF THE DOWNWARD STELLAR FLUX
@@ -145,9 +156,4 @@
 C       NOW CALCULATE THE CUMULATIVE VISIBLE NET FLUX 
 
-
-        !print*,'fmdv',fmdv
-        !print*,'fzero',fzero
-
-
         NFLUXTOPV = NFLUXTOPV+(FLUXUP-FLUXDN)*FZERO
         DO L=1,L_NLAYRAD
@@ -161,4 +167,7 @@
      *      +(FLUXUP-FLUXDN)*FZERO
 
+c     flux at gnd (RDW)
+          NFLUXGNDV_nu(NW) = NFLUXGNDV_nu(NW)+FMDV(L_NLAYRAD)*FZERO
+
 
 C       THE DIFFUSE COMPONENT OF THE DOWNWARD STELLAR FLUX
@@ -169,4 +178,5 @@
   500 CONTINUE
 
+
 C     *** END OF MAJOR SPECTRAL INTERVAL LOOP IN THE VISIBLE*****
 
Index: /trunk/LMDZ.GENERIC/libf/phystd/simpleprof_fn.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/simpleprof_fn.F90	(revision 253)
+++ /trunk/LMDZ.GENERIC/libf/phystd/simpleprof_fn.F90	(revision 253)
@@ -0,0 +1,58 @@
+      subroutine simpleprof_fn(tsurf,temp,popsk,ISR,psurf)
+!     creates a kasting temperature profile
+use radcommon_h, only: sigma
+      implicit none
+
+#include "dimensions.h"
+#include "dimphys.h"
+#include "comcstfi.h"
+#include "callkeys.h"
+
+!      REAL play(nlayermx)   ! Pressure at the middle of the layers (Pa)
+!      REAL plev(nlayermx+1) ! intermediate pressure levels (pa)
+      REAL psurf,tsurf      
+      REAL temp(nlayermx)   ! temperature at the middle of the layers
+      real ISR, ALB
+
+      real popsk(nlayermx)  ! this is dodgy as in rest of code, zpopsk(ngridmx,nlayermx)
+                            ! but kastprof requires 1D, so its ok I guess
+      integer l,iter
+
+
+      if(startype.eq.1)then
+         ALB=0.2+0.1*log10(psurf/100000.)
+      else
+         ALB=0.15
+      end if
+
+      Tstrat=((1-ALB)*ISR/(2*sigma))**0.25 ! skin temperature (gray approx.)
+      !Tstrat=60.                           ! minimum possible given H2-H2 CIA
+      print*,'psurf',psurf/100000.
+      print*,'ALB',ALB
+      print*,'Tstrat=',Tstrat
+
+      if(ngridmx.gt.1)then
+         print*,'DO NOT RUN KASTPROF IN 3D!!!'
+         call abort
+      end if
+
+      ! 1st, we make pot. temperature constant everywhere
+      do l=1,nlayermx
+            temp(l)=tsurf*popsk(l)
+      enddo
+
+      if(1.eq.1)then
+
+      do l=1,nlayermx-1
+            if (temp(l) .le. Tstrat)then
+               temp(l) = Tstrat            
+            endif
+      enddo
+
+      temp(nlayermx) = Tstrat
+
+      endif
+
+   
+   return
+ end subroutine simpleprof_fn
Index: /trunk/LMDZ.GENERIC/libf/phystd/soil.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/soil.F	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/soil.F	(revision 253)
@@ -35,15 +35,28 @@
 
 ! local saved variables:
-!      real,save :: layer(ngridmx,nsoilmx)	! layer depth
-      real,save :: mthermdiff(ngridmx,0:nsoilmx-1) ! mid-layer thermal diffusivity
-      real,save :: thermdiff(ngridmx,nsoilmx-1) ! inter-layer thermal diffusivity
-      real,save :: coefq(0:nsoilmx-1)		! q_{k+1/2} coefficients
-      real,save :: coefd(ngridmx,nsoilmx-1)	! d_k coefficients
-      real,save :: alph(ngridmx,nsoilmx-1)	! alpha_k coefficients
-      real,save :: beta(ngridmx,nsoilmx-1)	! beta_k coefficients
-      real,save :: mu
-      
+      !real,save :: mthermdiff(ngridmx,0:nsoilmx-1) ! mid-layer thermal diffusivity
+      !real,save :: thermdiff(ngridmx,nsoilmx-1) ! inter-layer thermal diffusivity
+      !real,save :: coefq(0:nsoilmx-1)		! q_{k+1/2} coefficients
+      !real,save :: coefd(ngridmx,nsoilmx-1)	! d_k coefficients
+      !real,save :: alph(ngridmx,nsoilmx-1)	! alpha_k coefficients
+      !real,save :: beta(ngridmx,nsoilmx-1)	! beta_k coefficients
+      !real,save :: mu
+
+      real mthermdiff(ngridmx,0:nsoilmx-1) ! mid-layer thermal diffusivity
+      real thermdiff(ngridmx,nsoilmx-1)    ! inter-layer thermal diffusivity
+      real coefq(0:nsoilmx-1)		   ! q_{k+1/2} coefficients
+      real coefd(ngridmx,nsoilmx-1)	   ! d_k coefficients
+      real alph(ngridmx,nsoilmx-1)	   ! alpha_k coefficients
+      real beta(ngridmx,nsoilmx-1)	   ! beta_k coefficients
+      real mu
+            
+      save mthermdiff,thermdiff,coefq,coefd,alph,beta,mu
+
 ! local variables:
       integer ig,ik
+
+
+!      print*,'tsoil=',tsoil
+!      print*,'tsurf=',tsurf
 
 ! 0. Initialisations and preprocessing step
@@ -104,8 +117,9 @@
         capcal(ig)=capcal(ig)/(1.+mu*(1.0-alph(ig,1))*
      &                         thermdiff(ig,1)/mthermdiff(ig,0))
-!      write(*,*)'soil: ig=',ig,' capcal(ig)=',capcal(ig)
+      !write(*,*)'soil: ig=',ig,' capcal(ig)=',capcal(ig)
       enddo ! of do ig=1,ngrid
             
       else ! of if (firstcall)
+
 
 !  1. Compute soil temperatures
@@ -142,4 +156,5 @@
       enddo
 
+
 !  3. Compute surface diffusive flux & calorific capacity
       do ig=1,ngrid
@@ -149,4 +164,12 @@
 !     &              (timestep*(1.-alph(ig,1)))
 ! Fstar
+
+!         print*,'this far in soil 1'
+!         print*,'thermdiff=',thermdiff(ig,1)
+!         print*,'mlayer=',mlayer
+!         print*,'beta=',beta(ig,1)
+!         print*,'alph=',alph(ig,1)
+!         print*,'tsoil=',tsoil(ig,1)
+
         fluxgrd(ig)=(thermdiff(ig,1)/(mlayer(1)-mlayer(0)))*
      &              (beta(ig,1)+(alph(ig,1)-1.0)*tsoil(ig,1))
@@ -163,4 +186,5 @@
       enddo
 
+
       end
 
Index: /trunk/LMDZ.GENERIC/libf/phystd/stelang.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/stelang.F	(revision 253)
+++ /trunk/LMDZ.GENERIC/libf/phystd/stelang.F	(revision 253)
@@ -0,0 +1,114 @@
+      subroutine stelang(kgrid,psilon,pcolon,psilat,pcolat,
+     &                    ptim1,ptim2,ptim3,pmu0,pfract )
+      IMPLICIT NONE
+
+C
+C**** *LW*   - ORGANIZES THE LONGWAVE CALCULATIONS
+C
+C     PURPOSE.
+C     --------
+C          CALCULATES THE STELLAR ANGLE FOR ALL THE POINTS OF THE GRID
+C
+C**   INTERFACE.
+C     ----------
+C      SUBROUTINE STELANG ( KGRID )
+C
+C        EXPLICIT ARGUMENTS :
+C        --------------------
+C     ==== INPUTS  ===
+C
+C PSILON(KGRID)   : SINUS OF THE LONGITUDE
+C PCOLON(KGRID)   : COSINUS OF THE LONGITUDE
+C PSILAT(KGRID)   : SINUS OF THE LATITUDE
+C PCOLAT(KGRID)   : COSINUS OF THE LATITUDE
+C PTIM1           : SIN(DECLI)
+C PTIM2           : COS(DECLI)*COS(TIME)
+C PTIM3           : SIN(DECLI)*SIN(TIME)
+C
+C     ==== OUTPUTS ===
+C
+C PMU0 (KGRID)    : SOLAR ANGLE
+C PFRACT(KGRID)   : DAY FRACTION OF THE TIME INTERVAL
+C
+C        IMPLICIT ARGUMENTS :   NONE
+C        --------------------
+C
+C     METHOD.
+C     -------
+C
+C     EXTERNALS.
+C     ----------
+C
+C         NONE
+C
+C     REFERENCE.
+C     ----------
+C
+C         RADIATIVE PROCESSES IN METEOROLOGIE AND CLIMATOLOGIE
+C         PALTRIDGE AND PLATT
+C
+C     AUTHOR.
+C     -------
+C        FREDERIC HOURDIN
+C
+C     MODIFICATIONS.
+C     --------------
+C        ORIGINAL :90-01-14
+C                  92-02-14 CALCULATIONS DONE THE ENTIER GRID (J.Polcher)
+C-----------------------------------------------------------------------
+C
+C     ------------------------------------------------------------------
+
+C-----------------------------------------------------------------------
+C
+C*      0.1   ARGUMENTS
+C             ---------
+C
+      INTEGER kgrid
+      REAL ptim1,ptim2,ptim3
+      REAL psilon(kgrid),pcolon(kgrid),pmu0(kgrid),pfract(kgrid)
+      REAL psilat(kgrid), pcolat(kgrid)
+C
+      INTEGER jl
+      REAL ztim1,ztim2,ztim3
+C------------------------------------------------------------------------
+C------------------------------------------------------------------------
+C------------------------------------------------------------------------
+C
+C------------------------------------------------------------------------
+C
+C*     1.     INITIALISATION
+C             --------------
+C
+ 100  CONTINUE
+C
+      DO jl=1,kgrid
+        pmu0(jl)=0.
+        pfract(jl)=0.
+      ENDDO
+C
+C*     1.1     COMPUTATION OF THE SOLAR ANGLE
+C              ------------------------------
+C
+      DO jl=1,kgrid
+        ztim1=psilat(jl)*ptim1
+        ztim2=pcolat(jl)*ptim2
+        ztim3=pcolat(jl)*ptim3
+        pmu0(jl)=ztim1+ztim2*pcolon(jl)+ztim3*psilon(jl)
+      ENDDO
+C
+C*     1.2      DISTINCTION BETWEEN DAY AND NIGHT
+C               ---------------------------------
+C
+      DO jl=1,kgrid
+        IF (pmu0(jl).gt.0.) THEN
+          pfract(jl)=1.
+c       pmu0(jl)=sqrt(1224.*pmu0(jl)*pmu0(jl)+1.)/35.
+      ELSE
+c       pmu0(jl)=0.
+        pfract(jl)=0.
+        ENDIF
+      ENDDO
+C
+      RETURN
+      END
Index: /trunk/LMDZ.GENERIC/libf/phystd/stellarlong.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/stellarlong.F	(revision 253)
+++ /trunk/LMDZ.GENERIC/libf/phystd/stellarlong.F	(revision 253)
@@ -0,0 +1,106 @@
+      SUBROUTINE stellarlong(pday,pstellong)
+      IMPLICIT NONE
+
+c=======================================================================
+c
+c   Objet:
+c   ------
+c
+c      Calcul de la distance soleil-planete et de la declinaison
+c   en fonction du jour de l'annee.
+c
+c
+c   Methode:
+c   --------
+c
+c      Calcul complet de l'elipse
+c
+c   Interface:
+c   ----------
+c
+c      Uncommon comprenant les parametres orbitaux.
+c
+c   Arguments:
+c   ----------
+c
+c   Input:
+c   ------
+c   pday          jour de l'annee (le jour 0 correspondant a l'equinoxe)
+c
+c   Output:
+c   -------
+c   pdist_star     distance entre le soleil et la planete
+c                 ( en unite astronomique pour utiliser la constante 
+c                  solaire terrestre 1370 Wm-2 )
+c   pdecli        declinaison ( en radians )
+c
+c=======================================================================
+c-----------------------------------------------------------------------
+c   Declarations:
+c   -------------
+
+#include "planete.h"
+#include "comcstfi.h"
+
+c arguments:
+c ----------
+
+      REAL pday,pdist_star,pdecli,pstellong
+      LOGICAL lwrite
+
+c Local:
+c ------
+
+      REAL zanom,xref,zx0,zdx,zteta,zz
+      INTEGER iter
+
+
+c-----------------------------------------------------------------------
+c calcul de l'angle polaire et de la distance au soleil :
+c -------------------------------------------------------
+
+c   Initialisation eventuelle:
+      if(.not.unitastr.gt.1.e-4) then
+         call iniorbit(249.22,206.66,669.,485.,25.2)
+      endif
+
+c  calcul de l'zanomalie moyenne
+
+      zz=(pday-peri_day)/year_day
+      pi=2.*asin(1.)
+      zanom=2.*pi*(zz-nint(zz))
+      xref=abs(zanom)
+
+c  resolution de l'equation horaire  zx0 - e * sin (zx0) = xref
+c  methode de Newton
+
+      zx0=xref+e_elips*sin(xref)
+      DO 110 iter=1,10
+         zdx=-(zx0-e_elips*sin(zx0)-xref)/(1.-e_elips*cos(zx0))
+         if(abs(zdx).le.(1.e-7)) goto 120
+         zx0=zx0+zdx
+110   continue
+120   continue
+      zx0=zx0+zdx
+      if(zanom.lt.0.) zx0=-zx0
+
+c zteta est la longitude solaire
+
+      zteta=2.*atan(sqrt((1.+e_elips)/(1.-e_elips))*tan(zx0/2.))
+
+      pstellong=zteta-timeperi
+
+      IF(pstellong.LT.0.) pstellong=pstellong+2.*pi
+      IF(pstellong.GT.2.*pi) pstellong=pstellong-2.*pi
+c-----------------------------------------------------------------------
+c   sorties eventuelles:
+c   ---------------------
+
+c     IF (lwrite) THEN
+c        PRINT*,'jour de l"annee   :',pday
+c        PRINT*,'distance au soleil (en unite astronomique) :',pdist_star
+c        PRINT*,'declinaison (en degres) :',pdecli*180./pi
+c     ENDIF
+
+      RETURN
+      END
Index: /trunk/LMDZ.GENERIC/libf/phystd/stokes.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/stokes.F90	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/stokes.F90	(revision 253)
@@ -30,6 +30,6 @@
 
 !     locally saved variables
-!     -----------------------
-      real a,b
+!     ---------------------
+      real a,b,molrad,visc
       save a,b
   
@@ -43,6 +43,18 @@
 	 !stop
          !a = 0.707*Rgas/(4*pi*molrad**2 * avocado)
+
+         molrad=2.2e-10   ! CO2 (only used in condense_co2cloud at the moment)
+         visc=1.e-5       ! CO2
+
+
          a = 0.707*R/(4*pi*molrad**2 * avocado)
-         b = (2./9.) * rho_aer * g / visc  
+         b = (2./9.) * rho_aer * g / visc 
+	!print*,'molrad=',molrad
+	!print*,'visc=',visc
+	!print*,'a=',a
+	!print*,'b=',b
+	!print*,'rho_aer=',rho_aer
+	!stop
+ 
          firstcall=.false.
       end if
@@ -52,5 +64,4 @@
 !     slip-flow correction according to Rossow (Icarus 36, 1-50, 1978)
       w = b * rd*rd * (1 + 1.333* (a*T/P)/rd )  
-
       return
     end subroutine stokes
Index: /trunk/LMDZ.GENERIC/libf/phystd/su_gases.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/su_gases.F90	(revision 253)
+++ /trunk/LMDZ.GENERIC/libf/phystd/su_gases.F90	(revision 253)
@@ -0,0 +1,74 @@
+subroutine su_gases
+
+  implicit none
+
+#include "gases.h"
+
+       integer ngas, igas, ierr
+
+!==================================================================
+!     
+!     Purpose
+!     -------
+!     Load atmospheric composition info
+!     
+!     Authors
+!     -------
+!     R. Wordsworth (2011)
+!     
+!==================================================================
+
+       ! load gas names from file 'gases.def'
+       open(90,file='gases.def',status='old',form='formatted',iostat=ierr)
+       if (ierr.eq.0) then
+          write(*,*) "sugases.F90: reading file gases.def"
+          read(90,*)
+          read(90,*,iostat=ierr) ngas
+          if (ierr.ne.0) then
+             write(*,*) "sugases.F90: error reading number of gases"
+             write(*,*) "   (first line of gases.def) "
+             call abort
+          endif
+          ! check that the number of gases is indeed ngasmx
+          if (ngas.ne.ngasmx) then
+             write(*,*) "sugases.F90: error, wrong number of gases:"
+             write(*,*) "ngas=",ngas," whereas ngasmx=",ngasmx
+             call abort
+          endif
+
+          do igas=1,ngas
+             read(90,*,iostat=ierr) gnom(igas)
+             if (ierr.ne.0) then
+                write(*,*) 'sugases.F90: error reading gas names...'
+                call abort
+             endif
+          enddo                  !of do igas=1,ngas
+          
+          vgas=0
+          do igas=1,ngas
+             read(90,*,iostat=ierr) gfrac(igas)
+             if (ierr.ne.0) then
+                write(*,*) 'sugases.F90: error reading gas molar fractions...'
+                call abort
+             endif
+
+             ! find variable gas (if any)
+             if(gfrac(igas).eq.-1.0)then 
+                if(vgas.eq.0)then
+                   vgas=igas
+                else
+                   print*,'You seem to be choosing two variable gases'
+                   print*,'Check that gases.def is correct'
+                   call abort
+                endif
+             endif
+             
+          enddo                  !of do igas=1,ngas
+
+       else
+          write(*,*) 'Cannot find required file "gases.def"'
+          call abort
+       endif
+       close(90)
+
+end subroutine su_gases
Index: /trunk/LMDZ.GENERIC/libf/phystd/su_watercycle.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/su_watercycle.F90	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/su_watercycle.F90	(revision 253)
@@ -21,8 +21,11 @@
       RCPD   = cpp 
 
-      RV     = 1000.*R/mH2O
-      RCPV   = 4. *RV
-      RVTMP2 = RCPV/RCPD-1.
+      !RV = 1000.*R/mH2O
+      RV = 1000.*8.314/mH2O ! caution! R is R/mugaz already!
 
+      RCPV   = 4. *RV	 ! could be more precise...
+      !RCPV   = 5/2 *8.31*1000/mH2O ! BC modif here: doesn't appear to be correct
+
+      RVTMP2 = RCPV/RCPD-1. ! not currently used...
 
       end subroutine su_watercycle
Index: /trunk/LMDZ.GENERIC/libf/phystd/suaer_corrk.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/suaer_corrk.F90	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/suaer_corrk.F90	(revision 253)
@@ -77,6 +77,6 @@
 !     the single scattering parameters)
 
-      REAL lamref              ! reference wavelengths
-      REAL epref                ! reference extinction ep
+      REAL lamref                      ! reference wavelengths
+      REAL epref                       ! reference extinction ep
 
 !      REAL epav(L_NSPECTI)            ! Average ep (= <Qext>/Qext(lamref) if epref=1)
@@ -103,5 +103,5 @@
       forgetit=.true.
 
-!     naerkind=1: overrides dust
+!     naerkind=1
 !     visible
       if(forgetit)then
@@ -121,6 +121,6 @@
          
 ! NOTE: these lamref's are currently for dust, not CO2 ice.
-! JB thinks this shouldn't matter too much, but it needs to be fixed for the 
-! final version.
+! JB thinks this shouldn't matter too much, but it needs to be 
+! fixed / decided for the final version.
 
       IF (naerkind .gt. 1) THEN
@@ -132,10 +132,22 @@
          file_id(2,2) = 'optprop_iceir_n50.dat'
          lamrefir(2)=12.1E-6   ! 825cm-1 TES/MGS
-!         ENDIF
       ENDIF
 
-      IF (naerkind .gt. 2) THEN
+      IF (naerkind .eq. 3) THEN
+!     naerkind=3
+!     visible
+         file_id(naerkind,1) = 'optprop_dustvis_n50.dat'
+         !lamrefvis(3)=1.5E-6   ! 1.5um OMEGA/MEx
+         lamrefvis(naerkind)=0.67e-6
+!     infrared
+         file_id(naerkind,2) = 'optprop_dustir_n50.dat'
+         !lamrefir(3)=12.1E-6   ! 825cm-1 TES/MGS
+         lamrefir(naerkind)=9.3E-6
+
+      ENDIF
+
+      IF (naerkind .gt. 3) THEN
          print*,'naerkind = ',naerkind
-         print*,'but we only have data for 2 types, exiting.'
+         print*,'but we only have data for 3 types, exiting.'
          call abort
       ENDIF
@@ -144,12 +156,4 @@
 
 !     Initializations:
-
-!      call zerophys(nsizemax*2*naerkind,radiustab)
-!      call zerophys(nsizemax*naerkind*L_NSPECTV,gvis)
-!      call zerophys(nsizemax*naerkind*L_NSPECTV,omegavis)
-!      call zerophys(nsizemax*naerkind*L_NSPECTV,QVISsQREF)
-!      call zerophys(nsizemax*naerkind*L_NSPECTI,gIR)
-!      call zerophys(nsizemax*naerkind*L_NSPECTI,omegaIR)
-!      call zerophys(nsizemax*naerkind*L_NSPECTI,QIRsQREF)
 
       radiustab(:,:,:) = 0.0
@@ -308,4 +312,9 @@
       endif
 
+
+
+
+
+
 !==================================================================
 !     2. AVERAGED PROPERTIES AND VARIABLE ASSIGNMENTS
@@ -392,5 +401,4 @@
       END SELECT domain
 
-
 !========================================================================
 !     3. Deallocate temporary variables that were read in the ASCII files
@@ -406,5 +414,9 @@
       END DO                    ! Loop on idomain
 !========================================================================
+
       RETURN
+
+
+
     END subroutine suaer_corrk
       
Index: /trunk/LMDZ.GENERIC/libf/phystd/sugas_corrk.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/sugas_corrk.F90	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/sugas_corrk.F90	(revision 253)
@@ -2,5 +2,5 @@
 
 !==================================================================
-!     
+!
 !     Purpose
 !     -------
@@ -8,12 +8,12 @@
 !     This subroutine is a replacement for the old 'setrad', which contained
 !     both absorption and scattering data.
-!     
+!
 !     Authors
 !     -------
 !     Adapted and generalised from the NASA Ames code by Robin Wordsworth (2009)
-!     
+!
 !     Summary
 !     -------
-!     
+!
 !==================================================================
 
@@ -28,4 +28,5 @@
 #include "datafile.h"
 #include "callkeys.h"
+#include "gases.h"
 
 !==================================================================
@@ -44,6 +45,8 @@
       real*8 x, xi(4), yi(4), ans, p
 
-      integer Nspecies
-
+      integer ngas, igas
+
+      ! temporary special for addh2
+      double precision testH2
 
 !=======================================================================
@@ -51,4 +54,5 @@
       file_id='/corrk_data/' // corrkdir(1:LEN_TRIM(corrkdir)) // '/Q.dat'
       file_path=datafile(1:LEN_TRIM(datafile))//file_id(1:LEN_TRIM(file_id))
+
 
       ! check that the file exists
@@ -62,24 +66,35 @@
       ! check that database matches varactive toggle
       open(111,file=file_path(1:LEN_TRIM(file_path)),form='formatted')
-      read(111,*) Nspecies
-
-      if(Nspecies.eq.1 .and. (varactive.or.varfixed))then
+      read(111,*) ngas
+
+      if(ngas.ne.ngasmx)then
+         print*,'Number of gases in radiative transfer data (',ngas,') does not', &
+                'match that in gases.def (',ngasmx,'), exiting.'
+         call abort
+      endif 
+
+      if(ngas.eq.1 .and. (varactive.or.varfixed))then
          print*,'You have varactive/fixed=.true. but the database [',  &
                      corrkdir(1:LEN_TRIM(corrkdir)),           &
                 '] has no variable species, exiting.'
          call abort
-      elseif(Nspecies.eq.2 .and. (.not.varactive) .and. (.not.varfixed))then
+      elseif(ngas.eq.2 .and. (.not.varactive) .and. (.not.varfixed))then
          print*,'You have varactive and varfixed=.false. and the database [', &
                      corrkdir(1:LEN_TRIM(corrkdir)),           &
                 '] has a variable species.'
          call abort
-      elseif(Nspecies.gt.3 .or. Nspecies.lt.1)then
-         print*,Nspecies,' species in database [',               &
+      elseif(ngas.gt.4 .or. ngas.lt.1)then
+         print*,ngas,' species in database [',               &
                      corrkdir(1:LEN_TRIM(corrkdir)),           &
                 '], radiative code cannot handle this.'
          call abort
-      endif
-
-      do n=1,Nspecies
+      endif 
+
+      if(ngas.gt.3)then
+         print*,'ngas>3, EXPERIMENTAL!'
+      endif
+
+
+      do n=1,ngas
          read(111,*) gastype(n)
          print*,'Gas ',n,' is ',gastype(n)
@@ -89,5 +104,7 @@
       open(111,file=file_path(1:LEN_TRIM(file_path)),form='formatted')
       read(111,*) L_REFVARcheck
-      if(.not.(L_REFVARcheck.eq.L_REFVAR)) then      
+      if(.not.(L_REFVARcheck.eq.L_REFVAR)) then   
+         print*,   L_REFVARcheck
+         print*,   L_REFVAR
          print*,'The size of your radiative transfer mixing ratio array does '
          print*,'not match the value given in Q.dat, exiting.'
@@ -96,12 +113,22 @@
       read(111,*) wrefvar
       close(111)
+
+      ! Check that gastype and gnom match
+      do n=1,ngas
+         print*,'Gas ',n,' is ',gnom(n)
+         if(gnom(n).ne.gastype(n))then
+            print*,'Name of a gas in radiative transfer data (',gastype(n),') does not', &
+                 'match that in gases.def (',gnom(n),'), exiting.'
+         endif
+      enddo
+      print*,'Confirmed gas match in radiative transfer and gases.def!'
 
       ! display the values
       print*,'Variable gas mixing ratios:'
       do n=1,L_REFVAR
-         print*,n,'.',wrefvar(n),' kg/kg'
+         !print*,n,'.',wrefvar(n),' kg/kg' ! pay attention!
+         print*,n,'.',wrefvar(n),' mol/mol'
       end do
       print*,''
-
 
 !=======================================================================
@@ -184,6 +211,5 @@
       end do
       pfgasref(L_PINT) = pgasref(L_NPREF)
-      ! Warning! this may need to be generalised if we want to use uneven grids!
-
+      print*,'Warning, pfgasref needs generalisation to uneven grids!!'
 
 !-----------------------------------------------------------------------
@@ -225,6 +251,6 @@
 !     Get gaseous k-coefficients and interpolate onto finer pressure grid
 
-         ! VISIBLE
-      if (callgasvis) then
+      ! VISIBLE
+      if (callgasvis.and..not.corrkdir(1:LEN_TRIM(corrkdir)).eq.'null') then
          file_id='/corrk_data/'//trim(adjustl(banddir))//'/corrk_gcm_VI.dat' 
          file_path=datafile(1:LEN_TRIM(datafile))//file_id(1:LEN_TRIM(file_id))
@@ -244,30 +270,37 @@
          
       else
-         print*,'Visible gaseous absorption is set to zero.'
+         print*,'Visible corrk gaseous absorption is set to zero.'
+         gasv8(:,:,:,:,:)=0.0
       endif
 
       ! INFRA-RED
-      file_id='/corrk_data/'//trim(adjustl(banddir))//'/corrk_gcm_IR.dat' 
-      file_path=datafile(1:LEN_TRIM(datafile))//file_id(1:LEN_TRIM(file_id))
+      if (.not.corrkdir(1:LEN_TRIM(corrkdir)).eq.'null') then
+         file_id='/corrk_data/'//trim(adjustl(banddir))//'/corrk_gcm_IR.dat' 
+         file_path=datafile(1:LEN_TRIM(datafile))//file_id(1:LEN_TRIM(file_id))
       
-      ! check that the file exists
-      inquire(FILE=file_path,EXIST=file_ok)
-      if(.not.file_ok) then
-         write(*,*)'The file ',file_path(1:LEN_TRIM(file_path))
-         write(*,*)'was not found by sugas_corrk.F90.'
-         write(*,*)'Are you sure you have absorption data for these bands?'
-         call abort
-      endif
+         ! check that the file exists
+         inquire(FILE=file_path,EXIST=file_ok)
+         if(.not.file_ok) then
+            write(*,*)'The file ',file_path(1:LEN_TRIM(file_path))
+            write(*,*)'was not found by sugas_corrk.F90.'
+            write(*,*)'Are you sure you have absorption data for these bands?'
+            call abort
+         endif
+         
+         open(111,file=file_path(1:LEN_TRIM(file_path)),form='formatted')
+         read(111,*) gasi8
+         close(111)
       
-      open(111,file=file_path(1:LEN_TRIM(file_path)),form='formatted')
-      read(111,*) gasi8
-      close(111)
-      
-      do nw=1,L_NSPECTI
-         fzeroi(nw) = 0.
-      end do
-      do nw=1,L_NSPECTV
-         fzerov(nw) = 0.
-      end do
+         do nw=1,L_NSPECTI
+            fzeroi(nw) = 0.
+         end do
+         do nw=1,L_NSPECTV
+            fzerov(nw) = 0.
+         end do
+
+      else
+         print*,'Infrared corrk gaseous absorption is set to zero.'
+         gasi8(:,:,:,:,:)=0.0
+      endif
 
 !     Take log10 of the values - this is what we will interpolate.
@@ -440,4 +473,11 @@
       end do
 
+      do igas=1,ngasmx
+         if(gnom(igas).eq.'H2_')then 
+            call interpolateH2H2(500.D+0,250.D+0,17500.D+0,testH2,.true.)
+         endif
+      enddo
+
+
       return
     end subroutine sugas_corrk
Index: /trunk/LMDZ.GENERIC/libf/phystd/surface_nature.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/surface_nature.F	(revision 253)
+++ /trunk/LMDZ.GENERIC/libf/phystd/surface_nature.F	(revision 253)
@@ -0,0 +1,66 @@
+      SUBROUTINE surface_nature(obliquit,qsurf,qsurfliquid
+     &   ,qsurfsnow,rnat,oceanarea)
+      IMPLICIT none
+
+!==================================================================
+!     
+!     Purpose
+!     -------
+!     Defines a few things
+!     
+!     Authors
+!     ------- 
+!     B. Charnay (2010)
+!     
+!     Called by
+!     ---------
+!     physiq.F
+!     
+!     Calls
+!     -----
+!     none
+!
+!     Notes
+!     -----
+!     rnat is terrain type: 0-ocean; 1-continent; 2-continental ice
+!     
+!==================================================================
+
+#include "dimensions.h"
+#include "dimphys.h"
+#include "comcstfi.h"
+#include "callkeys.h"
+#include "tracer.h"
+#include "fisice.h"
+#include "comgeomfi.h"
+#include "surfdat.h"
+#include "comsoil.h"
+
+	REAL qsurf(ngridmx,nqmx),ps(ngridmx)
+	REAL qsurfliquid(ngridmx)
+	REAL qsurfsnow(ngridmx)
+	INTEGER iq, ig
+	INTEGER rnat(ngridmx)
+ 	REAL oceanarea
+	REAL obliquit
+
+	do ig=1,ngridmx
+           rnat(ig)=1
+           dryness(ig)=1        !(coefficient for evaporation)
+           if (inertiedat(ig,1).gt.1E4) then
+              rnat(ig)=0
+           end if
+	end do
+
+! surface of all the oceans
+        
+        oceanarea=0.
+	do ig=1,ngridmx
+           if (rnat(ig).eq.0)then
+              oceanarea=oceanarea+area(ig)
+           end if
+	enddo
+
+        return
+        end
+
